#include <gtk/gtk.h>
#include <glade/glade.h>

void show_web_page (GtkWidget *widget, gpointer user_data)
{
  GtkTextBuffer *buffer;

  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));

  gtk_text_buffer_set_text (buffer, "", -1);
}

void show_source (GtkWidget *widget, gpointer user_data)
{
  GtkTextBuffer *buffer;

  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));

  gtk_text_buffer_set_text (buffer, "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\"\n    \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"de\">\n\n<head>\n\n<meta http-equiv=\"Content-Type\" content=\"application/xhtml+xml;charset=UTF-8\" />\n\n<title></title>\n\n</head>\n\n<body>\n</body>\n\n</html>", -1);
}

void about (GtkWidget *widget, gpointer user_data)
{
  gtk_show_about_dialog (GTK_WINDOW(user_data),
                         "license", "Dieser Werk ist unter einer Creative Commons-Lizenz (http://creativecommons.org/licenses/by-nc-sa/2.0/de/) lizenziert.",
                         "wrap-license", TRUE,
                         "program-name", "SurfBoard",
                         "version", "0.1",
                         "website", "http://www.mellthas.de/surfboard/",
                         NULL);
}

int main (int argc, char *argv[])
{
  GladeXML  *main_window;
  GtkWidget *widget;
  GtkWidget *mainwindow;
  GtkWidget *view;
  
  gtk_init (&argc, &argv);
  
  /* load the interface */
  main_window = glade_xml_new ("surfboard.glade", NULL, NULL);
  
  /* Main window */
  mainwindow = glade_xml_get_widget (main_window, "MainWindow");
  
  /* Close window */
  widget = glade_xml_get_widget (main_window, "CloseItem");
  g_signal_connect (G_OBJECT (widget), "activate",
                    G_CALLBACK (gtk_main_quit),
                    NULL);
  g_signal_connect (G_OBJECT (mainwindow), "delete_event",
                    G_CALLBACK (gtk_main_quit),
                    NULL);
        
  /* View */
  view = glade_xml_get_widget (main_window, "View");

  widget = glade_xml_get_widget (main_window, "WebPageItem");
  g_signal_connect (G_OBJECT (widget), "activate",
                    G_CALLBACK (show_web_page),
                    view);
  widget = glade_xml_get_widget (main_window, "SourceItem");
  g_signal_connect (G_OBJECT (widget), "activate",
                    G_CALLBACK (show_source),
                    view);
  
  /* About Dialog */
  widget = glade_xml_get_widget (main_window, "InfoItem");
  g_signal_connect (G_OBJECT (widget), "activate",
                    G_CALLBACK (about),
                    mainwindow);
  
  /* Show the main window */
  
  gtk_widget_show (mainwindow);

  gtk_main ();

  return 0;
}
